
-- Author: Unknown
-- Name: script name
-- Description: script description
-- Icon:
-- Hide: no

Backtrailer = {};

Backtrailer.modDir = g_currentModDirectory;

function Backtrailer.prerequisitesPresent(specializations)
    return true; 
end;


function Backtrailer:preLoad(savegame)
    self.setPickupState = Backtrailer.setPickupState;
	self.setPickupState1 = Backtrailer.setPickupState1;
	self.setPickupState2 = Backtrailer.setPickupState2;
end







function Backtrailer:load(savegame)

    self.playerCallbackDoor = SpecializationUtil.callSpecializationsFunction("playerCallbackDoor"); 
	self.playerCallbackDoor1 = SpecializationUtil.callSpecializationsFunction("playerCallbackDoor1");
	self.playerCallbackDoor2 = SpecializationUtil.callSpecializationsFunction("playerCallbackDoor2");
    
    self.doorO = {};
	local triggers = Utils.indexToObject( self.components, getXMLString(self.xmlFile, string.format("vehicle.backtrailer#trigger")) );
		if triggers == nil then
			print("trigger null");
			end;

    local triggers1 = Utils.indexToObject( self.components, getXMLString(self.xmlFile, string.format("vehicle.backtrailer#trigger1")) );
		if triggers1 == nil then
			print("trigger 1 null");
			end;
    local triggers2 = Utils.indexToObject( self.components, getXMLString(self.xmlFile, string.format("vehicle.backtrailer#trigger2")) );
		if triggers2 == nil then
			print("trigger 2 null");
			end;
	
	
	
	print(triggers)
	self.doorO.trigger = triggers;
	self.doorO.trigger1 = triggers1;
	self.doorO.trigger2 = triggers2;
	
    if self.doorO.trigger ~= nil then
	addTrigger( triggers, "playerCallbackDoor", self );
	self.doorO.alIR = false;
	end;
	if self.doorO.trigger1 ~= nil then
	addTrigger( triggers1, "playerCallbackDoor1", self );
	self.doorO.blIR = false;
	end;
	if self.doorO.trigger2 ~= nil then
	addTrigger( triggers2, "playerCallbackDoor2", self );
	self.doorO.clIR = false;
	end;
	

	
 
	
	self.isPickupLowered = false;
	self.pickupAnimationName = Utils.getNoNil(getXMLString(self.xmlFile, "vehicle.backtrailer#name"), "");
	print(self.pickupAnimationName);
	
	self.isPickupLowered1 = false;
	self.pickupAnimationName1 = Utils.getNoNil(getXMLString(self.xmlFile, "vehicle.backtrailer#name1"), "");
	print(self.pickupAnimationName1);
	
	self.isPickupLowered2 = false;
	self.pickupAnimationName2 = Utils.getNoNil(getXMLString(self.xmlFile, "vehicle.backtrailer#name2"), "");
	print(self.pickupAnimationName2);
		


	
    
	
    self.pickupAnimationLowerSpeed = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.backtrailer#lowerSpeed"), 1);
    self.pickupAnimationLiftSpeed = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.backtrailer#liftSpeed"), -self.pickupAnimationLowerSpeed);
end;

function Backtrailer:postLoad(savegame)
    if self.pickupAnimationName ~= "" then
        local dir = -20;
        self:playAnimation(self.pickupAnimationName, dir, nil, true);
        AnimatedVehicle.updateAnimations(self, 99999999);
    end;
	if self.pickupAnimationName1 ~= "" then
		local dir = -20;
		self:playAnimation(self.pickupAnimationName1, dir, nil, true);
        AnimatedVehicle.updateAnimations(self, 99999999);
    end;
	if self.pickupAnimationName2 ~= "" then
		local dir = -20;
		self:playAnimation(self.pickupAnimationName2, dir, nil, true);
        AnimatedVehicle.updateAnimations(self, 99999999);
    end;
end


function Backtrailer:delete()
    if self.doorO.trigger ~= nil then
        removeTrigger(self.doorO.trigger);
	end;	
	if self.doorO.trigger1 ~= nil then
        removeTrigger(self.doorO.trigger1);
	end;	
	if self.doorO.trigger2 ~= nil then
        removeTrigger(self.doorO.trigger2);
	end;
end;

function Backtrailer:readStream(streamId, connection)
    local isPickupLowered = streamReadBool(streamId);
    self:setPickupState(isPickupLowered, true);
	local isPickupLowered1 = streamReadBool(streamId);
    self:setPickupState1(isPickupLowered1, true);
	local isPickupLowered2 = streamReadBool(streamId);
    self:setPickupState2(isPickupLowered2, true);
	
end;


function Backtrailer:writeStream(streamId, connection)
  streamWriteBool(streamId, self.isPickupLowered);
  streamWriteBool(streamId, self.isPickupLowered1);
  streamWriteBool(streamId, self.isPickupLowered2);
  
end;

function Backtrailer:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Backtrailer:keyEvent(unicode, sym, modifier, isDown)
end;

function Backtrailer:update(dt)
    
    if self.doorO.alIR or self.doorO.blIR or self.doorO.clIR then
        g_currentMission:addHelpButtonText( g_i18n:getText("SET_DOOROPENER"), InputBinding.SET_DOOROPENER );    
        if InputBinding.hasEvent(InputBinding.SET_DOOROPENER)then
			if self.doorO.alIR then
				self:setPickupState(not self.isPickupLowered);
				print(self.pickupAnimationName);
			end;
			if self.doorO.blIR then
				self:setPickupState1(not self.isPickupLowered1);
				print(self.pickupAnimationName1);
			end;
			if self.doorO.clIR then
				self:setPickupState2(not self.isPickupLowered2);
				print(self.pickupAnimationName2);
			end;
		
			
						
        end
	end;
end;

function Backtrailer:onLeave()
end;

function Backtrailer:draw()
end;



function Backtrailer:setPickupState(isPickupLowered, noEventSend)
    PickupSetStateEvent.sendEvent(self, isPickupLowered, noEventSend)
    self.isPickupLowered = isPickupLowered;
    if self.pickupAnimationName ~= "" then
        local animTime = nil;
        if self:getIsAnimationPlaying(self.pickupAnimationName) then
            animTime = self:getAnimationTime(self.pickupAnimationName);
        end;
        if isPickupLowered then
            self:playAnimation(self.pickupAnimationName, self.pickupAnimationLowerSpeed, animTime, true)
        else
            self:playAnimation(self.pickupAnimationName, self.pickupAnimationLiftSpeed, animTime, true)
        end;
    end;
end;

function Backtrailer:setPickupState1(isPickupLowered1, noEventSend)
    PickupSetStateEvent.sendEvent(self, isPickupLowered1, noEventSend)
    self.isPickupLowered1 = isPickupLowered1;
    if self.pickupAnimationName1 ~= "" then
        local animTime = nil;
        if self:getIsAnimationPlaying(self.pickupAnimationName1) then
            animTime = self:getAnimationTime(self.pickupAnimationName1);
        end;
        if isPickupLowered1 then
            self:playAnimation(self.pickupAnimationName1, self.pickupAnimationLowerSpeed, animTime, true)
        else
            self:playAnimation(self.pickupAnimationName1, self.pickupAnimationLiftSpeed, animTime, true)
        end;
    end;
end;

function Backtrailer:setPickupState2(isPickupLowered2, noEventSend)
    PickupSetStateEvent.sendEvent(self, isPickupLowered2, noEventSend)
    self.isPickupLowered2 = isPickupLowered;
    if self.pickupAnimationName2 ~= "" then
        local animTime = nil;
        if self:getIsAnimationPlaying(self.pickupAnimationName2) then
            animTime = self:getAnimationTime(self.pickupAnimationName2);
        end;
        if isPickupLowered2 then
            self:playAnimation(self.pickupAnimationName2, self.pickupAnimationLowerSpeed, animTime, true)
        else
            self:playAnimation(self.pickupAnimationName2, self.pickupAnimationLiftSpeed, animTime, true)
        end;
    end;
end;



function Backtrailer:playerCallbackDoor(triggerId, otherId, onEnter, onLeave, onStay)
    
    if onEnter and g_currentMission.controlPlayer and g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
			self.doorO.alIR = true;
			print(triggerId)
    elseif onLeave and g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
        self.doorO.alIR = false;
    end;
    
end;

function Backtrailer:playerCallbackDoor1(triggerId, otherId, onEnter, onLeave, onStay)
    
    if onEnter and g_currentMission.controlPlayer and g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
			self.doorO.blIR = true;
			print(triggerId)
    elseif onLeave and g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
        self.doorO.blIR = false;
    end;
    
end;

function Backtrailer:playerCallbackDoor2(triggerId, otherId, onEnter, onLeave, onStay)
    
    if onEnter and g_currentMission.controlPlayer and g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
			self.doorO.clIR = true;
			print(triggerId)
    elseif onLeave and g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
        self.doorO.clIR = false;
    end;
    
end;

